//
// Sensitive for Cybiko by ssjx (2023)
//
// v0.2 (Sept 2023)
// + Title screen
// + Late variable declare/inits
// + General tidy
//

#include <cybiko.h>

struct Message* ptr_message;
struct module_t main_module;

int waitinput(struct module_t *);

const char TITLE[]="Sensitive";
const char URL[]="https://ssjx.co.uk";
const char VERSION[]="v0.2";


void shadow(char *out,char *in,int x,int y){
	int pos=(y*320)+(x*2)+161;
	const int spos=160;	// 160 = 16 x #10

	out[pos+1]=in[spos+1];pos=pos+40;
	out[pos+1]=in[spos+3];pos=pos+40;
	out[pos+1]=in[spos+5];pos=pos+40;
	out[pos+1]=in[spos+7];pos=pos+40;

	memcpy((out+pos),(in+(spos)+8),2);pos=pos+40;
	memcpy((out+pos),(in+(spos)+10),2);pos=pos+40;
	memcpy((out+pos),(in+(spos)+12),2);pos=pos+40;
	memcpy((out+pos),(in+(spos)+14),2);
}

void ld_sprites(char *out){
	// Sprite #0 - Clear
	int pos=0*16;
	memset((out+pos),0x00,16);

	// Sprite #1 - Backgroud
	pos=1*16;
	out[pos++]=0x11;out[pos++]=0x11;
	out[pos++]=0x44;out[pos++]=0x44;
	out[pos++]=0x11;out[pos++]=0x11;
	out[pos++]=0x44;out[pos++]=0x44;
	out[pos++]=0x11;out[pos++]=0x11;
	out[pos++]=0x44;out[pos++]=0x44;
	out[pos++]=0x11;out[pos++]=0x11;
	out[pos++]=0x44;out[pos++]=0x44;

	// Sprite #2 - One Hit
	pos=2*16;
	out[pos++]=0x55;out[pos++]=0x55;
	out[pos++]=0x40;out[pos++]=0x01;
	out[pos++]=0x40;out[pos++]=0x01;
	out[pos++]=0x40;out[pos++]=0x01;
	out[pos++]=0x40;out[pos++]=0x01;
	out[pos++]=0x40;out[pos++]=0x01;
	out[pos++]=0x40;out[pos++]=0x01;
	out[pos++]=0x55;out[pos++]=0x55;

	// Sprite #3 - Two Hit
	pos=3*16;
	out[pos++]=0x55;out[pos++]=0x55;
	out[pos++]=0x40;out[pos++]=0x01;
	out[pos++]=0x45;out[pos++]=0x51;
	out[pos++]=0x44;out[pos++]=0x11;
	out[pos++]=0x44;out[pos++]=0x11;
	out[pos++]=0x45;out[pos++]=0x51;
	out[pos++]=0x40;out[pos++]=0x01;
	out[pos++]=0x55;out[pos++]=0x55;

	// Sprite #4 - Player
	pos=4*16;
	memset((out+pos),0xff,16);

	// Sprite #5 - Start
	pos=5*16;
	out[pos++]=0x00;out[pos++]=0x00;
	out[pos++]=0xff;out[pos++]=0xff;
	out[pos++]=0xf0;out[pos++]=0x00;
	out[pos++]=0xff;out[pos++]=0xff;
	out[pos++]=0x00;out[pos++]=0x0f;
	out[pos++]=0xff;out[pos++]=0xff;
	out[pos++]=0x00;out[pos++]=0x00;
	out[pos++]=0x00;out[pos++]=0x00;


	// Sprite #6 - Exit
	pos=6*16;
	out[pos++]=0x00;out[pos++]=0x00;
	out[pos++]=0xff;out[pos++]=0xff;
	out[pos++]=0xf0;out[pos++]=0x00;
	out[pos++]=0xff;out[pos++]=0xff;
	out[pos++]=0xf0;out[pos++]=0x00;
	out[pos++]=0xff;out[pos++]=0xff;
	out[pos++]=0x00;out[pos++]=0x00;
	out[pos++]=0x00;out[pos++]=0x00;

	// Sprite #10 - Shadow
	pos=10*16;
	out[pos++]=0x33;out[pos++]=0x33;
	out[pos++]=0xcc;out[pos++]=0xcc;
	out[pos++]=0x33;out[pos++]=0x33;
	out[pos++]=0xcc;out[pos++]=0xcc;
	out[pos++]=0x33;out[pos++]=0x33;
	out[pos++]=0xcc;out[pos++]=0xcc;
	out[pos++]=0x33;out[pos++]=0x33;
	out[pos++]=0xcc;out[pos++]=0xcc;
}

void sprite(char *out,char *in,int x,int y,int no){
	int pos=(y*320)+(x*2);
	int spos=16*no;

	memcpy((out+pos),(in+(spos)),2);pos=pos+40;
	memcpy((out+pos),(in+(spos)+2),2);pos=pos+40;
	memcpy((out+pos),(in+(spos)+4),2);pos=pos+40;
	memcpy((out+pos),(in+(spos)+6),2);pos=pos+40;

	memcpy((out+pos),(in+(spos)+8),2);pos=pos+40;
	memcpy((out+pos),(in+(spos)+10),2);pos=pos+40;
	memcpy((out+pos),(in+(spos)+12),2);pos=pos+40;
	memcpy((out+pos),(in+(spos)+14),2);
}


void drawlevel(char *scr,char *ar,char *bank){
	int i,j,sp;
	// Background Draw the first row...
	for (i=0;i<20;i++){
		sprite(scr,bank,i,0,1);
	}

	// ... and then copy down.
	for(i=1;i<10;i++){
		memcpy(scr+(i*320),scr,320);
	}

	// Everything else (inc shadow)
	for (j=0;j<10;j++){
		for (i=0;i<20;i++){
			sp=ar[(20*j)+i];

			if(sp!=1){
				shadow(scr,bank,i,j);
				sprite(scr,bank,i,j,sp);
			}
		}
	}

}

int squares(char *ar){
	int count=0,i,j;

	for (j=0;j<10;j++){
		for (i=0;i<20;i++){
			int sp=ar[(20*j)+i];
			if (sp==2 || sp==3){count++;}
		}
	}
	return count;
}

void setstart(char *ar,int *x,int *y){
	int i,j;

	for (j=0;j<10;j++){
		for (i=0;i<20;i++){
			if (ar[(20*j)+i]==5){
				*x=i;
				*y=j;
				return;
			}
		}
	}
}



int getinput(){
	struct DirectKeyboard* ptr_direct_keyboard;
	int mykey=0;

	ptr_direct_keyboard = DirectKeyboard_get_instance();
	DirectKeyboard_scan( ptr_direct_keyboard );

	if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_UP ) ){mykey=1;}

	if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_DOWN ) ){mykey=2;}

	if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_LEFT ) ){mykey=3;}

	if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_RIGHT ) ){mykey=4;}

	if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_SPACE ) ){mykey=-1;}
	if ( DirectKeyboard_is_key_pressed( ptr_direct_keyboard, KEY_Q ) ){mykey=-1;}

	DirectKeyboard_dtor( ptr_direct_keyboard, FREE_MEMORY );
	return mykey;
}

void ld_level(char *grid){
	long i;	
	long start=*grid;

	int offset=(0*200);
	memcpy((grid+offset),"11111111111111111111",20);offset+=20;
	memcpy((grid+offset),"15333322222222222221",20);offset+=20;
	memcpy((grid+offset),"12111211111111111121",20);offset+=20;
	memcpy((grid+offset),"12111211111111111121",20);offset+=20;
	memcpy((grid+offset),"12111211111111111121",20);offset+=20;
	memcpy((grid+offset),"12222211611111111121",20);offset+=20;
	memcpy((grid+offset),"11111111211111111121",20);offset+=20;
	memcpy((grid+offset),"11111111211111111121",20);offset+=20;
	memcpy((grid+offset),"12333333322222222221",20);offset+=20;
	memcpy((grid+offset),"11111111111111111111",20);

	offset=(1*200);
	memcpy((grid+offset),"11111111111111111111",20);offset+=20;
	memcpy((grid+offset),"15222232222222222211",20);offset+=20;
	memcpy((grid+offset),"11111131111111111211",20);offset+=20;
	memcpy((grid+offset),"11111131111111111211",20);offset+=20;
	memcpy((grid+offset),"11111131111111111211",20);offset+=20;
	memcpy((grid+offset),"11111131111111111211",20);offset+=20;
	memcpy((grid+offset),"11111131111111111211",20);offset+=20;
	memcpy((grid+offset),"11111131111111111211",20);offset+=20;
	memcpy((grid+offset),"16222232222222222211",20);offset+=20;
	memcpy((grid+offset),"11111111111111111111",20);

	offset=(2*200);
	memcpy((grid+offset),"11111111111111111111",20);offset+=20;
	memcpy((grid+offset),"12222262222222221111",20);offset+=20;
	memcpy((grid+offset),"12111112111111121111",20);offset+=20;
	memcpy((grid+offset),"12222223111222232251",20);offset+=20;
	memcpy((grid+offset),"11111113111211121111",20);offset+=20;
	memcpy((grid+offset),"11111113111211121111",20);offset+=20;
	memcpy((grid+offset),"12222223222322221111",20);offset+=20;
	memcpy((grid+offset),"12111111111211111111",20);offset+=20;
	memcpy((grid+offset),"12222222222211111111",20);offset+=20;
	memcpy((grid+offset),"11111111111111111111",20);

	offset=(3*200);
	memcpy((grid+offset),"11111111111111111111",20);offset+=20;
	memcpy((grid+offset),"11112222111111111111",20);offset+=20;
	memcpy((grid+offset),"11112222111111111111",20);offset+=20;
	memcpy((grid+offset),"11112222222111111111",20);offset+=20;
	memcpy((grid+offset),"11222111112221222111",20);offset+=20;
	memcpy((grid+offset),"11252111112221212111",20);offset+=20;
	memcpy((grid+offset),"11222111112222322111",20);offset+=20;
	memcpy((grid+offset),"11111111111111211111",20);offset+=20;
	memcpy((grid+offset),"11111111111111611111",20);offset+=20;
	memcpy((grid+offset),"11111111111111111111",20);

	// Turns string numbers '1' into integers e.g. 1
	for (i=start;i<(start+1000);i++){
		grid[i]=grid[i]-48;
	}
}

// ------------------------

void centre(struct module_t *ptr_main_module,char *text,int y){
	int width=Font_string_width( DisplayGraphics_get_font( ptr_main_module->m_gfx),text );
	int pos=(160-width)>>1;	    
	if (pos<0){pos=0;}

	DisplayGraphics_draw_text(ptr_main_module->m_gfx,text, pos, y );
}


long main(int argc, char *argv[],bool start){
	int i,j;
	int ext=0;
	int score=0,hiscore=10;
	char score_str[20],lives_str[20],gen_str[20];

	char *grid,*spritebank,*levelbank;
	char *dis;

	grid=(char *)malloc(210);
	spritebank=(char *)malloc(210); 
	levelbank=(char *)malloc(1000); 

	TRACE("Starting");
	init_module( &main_module );

	// Load Sprites
	TRACE("Load sprites");
	ld_sprites(spritebank);

	//Load Level
	TRACE("Loading Levels");
	ld_level(levelbank);

	dis=DisplayGraphics_get_page_ptr(main_module.m_gfx, 0);

	do{
		// Title Screen
		memset(dis,0,4000); // Clear screen
		
		TGraph_set_color( main_module.m_gfx, CLR_DKGRAY );
		
		centre( &main_module,"by ssjx",10);
		
		sprintf(score_str,"%d",hiscore);
		centre( &main_module, score_str,35);
		
		sprintf(score_str,"%d",score);
		centre( &main_module, score_str,55);
		
		TGraph_set_color( main_module.m_gfx, CLR_BLACK );
		
		centre( &main_module, TITLE, 1 );
		centre( &main_module, "High Score", 25 );
		centre( &main_module, "Previous Score", 45 );
		centre( &main_module, "Space = Start", 70 );
			
		//footer
		memset(dis+3560,0x55,440);
		TGraph_draw_line( main_module.m_gfx, 0, 88, 160, 88 );
		
		DisplayGraphics_draw_text( main_module.m_gfx, URL, 1, 90 );
		DisplayGraphics_draw_text( main_module.m_gfx, VERSION, 139, 90 );
		
		DisplayGraphics_show(main_module.m_gfx );
		ext=0;
		if (waitinput(&main_module)==KEY_ESC){
			TRACE("Escape from the title screen...");
			ext=2;
		}
		
		if (ext==0){
			int x=5,y=5;
			int lives=2;
			int levelno=0;
			score=0;
			//
			//
			do{
				// ext=0;
				TRACE("Get Ready!");
				sprintf(gen_str,"Level %d",(levelno+1));

				memcpy(grid,levelbank+(levelno*200),200);

				setstart(grid,&x,&y);

				DisplayGraphics_fill_screen(main_module.m_gfx, CLR_WHITE);

				drawlevel(DisplayGraphics_get_page_ptr(main_module.m_gfx, 0),grid,spritebank);

				TGraph_set_color( main_module.m_gfx, CLR_BLACK );
				TGraph_draw_hline( main_module.m_gfx, 0, 80, 159);

				TGraph_set_color( main_module.m_gfx, CLR_DKGRAY );
				TGraph_draw_hline( main_module.m_gfx, 0, 81, 159);

				TGraph_set_color( main_module.m_gfx, CLR_LTGRAY );
				TGraph_draw_hline( main_module.m_gfx, 0, 82, 159);     

				sprintf(score_str,"Score: %d",score);
				sprintf(lives_str,"Lives: %d",lives);

				TGraph_set_color( main_module.m_gfx, CLR_BLACK );
				DisplayGraphics_draw_text( main_module.m_gfx, score_str, 10, 85 );
				DisplayGraphics_draw_text( main_module.m_gfx, lives_str, 100, 85 );
				  
				TGraph_set_color( main_module.m_gfx, CLR_LTGRAY );
				TGraph_draw_hline( main_module.m_gfx, 0, 97, 159);     

				TGraph_set_color( main_module.m_gfx, CLR_DKGRAY );
				TGraph_draw_hline( main_module.m_gfx, 0, 98, 159);

				TGraph_set_color( main_module.m_gfx, CLR_BLACK );
				TGraph_draw_hline( main_module.m_gfx, 0, 99, 159);

				TGraph_set_color( main_module.m_gfx, CLR_WHITE );
				DisplayGraphics_draw_text( main_module.m_gfx, gen_str, 71, 31 );
				DisplayGraphics_draw_text( main_module.m_gfx, "Get Ready", 61, 41 );

				TGraph_set_color( main_module.m_gfx, CLR_BLACK );
				DisplayGraphics_draw_text( main_module.m_gfx, gen_str, 70, 30 );
				DisplayGraphics_draw_text( main_module.m_gfx, "Get Ready", 60, 40 );

				DisplayGraphics_show(main_module.m_gfx );

				sleep(2000);

				drawlevel(DisplayGraphics_get_page_ptr(main_module.m_gfx, 0),grid,spritebank);
				sprite(DisplayGraphics_get_page_ptr(main_module.m_gfx, 0),spritebank,x,y,4);

				DisplayGraphics_show(main_module.m_gfx );
				ext=0;
				do{
					int gi;
					if ((gi=getinput())!=0){
						int cx=x;
						int cy=y;

						switch(gi){
							case -1:
								ext=1;
								lives=-1;
							break;

							case 1:
								y--;
							break; 

							case 2:
								y++;
							break;

							case 3:
								x--;
							break;

							case 4:
								x++;
							break;
						}

						if (grid[(cy*20)+cx]==3 || grid[(cy*20)+cx]==2){
							grid[(cy*20)+cx]--;
							score++;
							sprintf(score_str,"Score: %d",score);
						}

						if (grid[(y*20)+x]==1){
							lives--;
							ext=1;
						}

						if (grid[(y*20)+x]==6 && squares(grid)==0){
							levelno++;
							ext=1;
						}
					}

					TGraph_set_color( main_module.m_gfx, CLR_WHITE );
					DisplayGraphics_fill_rect( main_module.m_gfx, 0, 83, 160, 15);
						 
					TGraph_set_color( main_module.m_gfx, CLR_BLACK );
					DisplayGraphics_draw_text( main_module.m_gfx, score_str, 10, 85 );
					DisplayGraphics_draw_text( main_module.m_gfx, lives_str, 100, 85 );

					drawlevel(DisplayGraphics_get_page_ptr(main_module.m_gfx, 0),grid,spritebank);

					sprite(DisplayGraphics_get_page_ptr(main_module.m_gfx, 0),spritebank,x,y,4);

					DisplayGraphics_show(main_module.m_gfx );
				}while(ext==0);
					
			}while(lives>-1 && levelno<4);
			
			if (score>hiscore){hiscore=score;}
		}	
	}while(ext!=2);
	
	TRACE("Finished");
	free(grid);
	free(spritebank);
	free(levelbank);
	return 0L;
}